blob: 2998ddb323e3c00ba9087a6acf81484387676724 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37 if [ "${quiet}" != "silent_" ]; then
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070038 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020039 fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
Stephen Rothwella5967db2016-08-24 22:29:19 +100046 local objects
47
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100048 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090049 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100050 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
Masahiro Yamadad503ac52018-08-24 08:20:39 +090055 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020056}
57
58# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070059# ${1} - output file
Andrii Nakryiko618916a2019-09-05 10:59:38 -070060# ${2}, ${3}, ... - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020061vmlinux_link()
62{
63 local lds="${objtree}/${KBUILD_LDS}"
Andrii Nakryiko618916a2019-09-05 10:59:38 -070064 local output=${1}
Stephen Rothwella5967db2016-08-24 22:29:19 +100065 local objects
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020066
Linus Torvaldsd7b08272019-09-20 08:36:47 -070067 info LD ${output}
68
Andrii Nakryiko618916a2019-09-05 10:59:38 -070069 # skip output file argument
70 shift
71
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020072 if [ "${SRCARCH}" != "um" ]; then
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100073 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090074 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100075 --no-whole-archive \
76 --start-group \
77 ${KBUILD_VMLINUX_LIBS} \
78 --end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -070079 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100080
Andrii Nakryiko618916a2019-09-05 10:59:38 -070081 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
82 -o ${output} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100083 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020084 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100085 objects="-Wl,--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090086 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100087 -Wl,--no-whole-archive \
88 -Wl,--start-group \
89 ${KBUILD_VMLINUX_LIBS} \
90 -Wl,--end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -070091 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100092
Andrii Nakryiko618916a2019-09-05 10:59:38 -070093 ${CC} ${CFLAGS_vmlinux} \
94 -o ${output} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100095 -Wl,-T,${lds} \
96 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100097 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020098 rm -f linux
99 fi
100}
101
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700102# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700103# ${1} - vmlinux image
104# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700105gen_btf()
106{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700107 local pahole_ver
108 local bin_arch
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700109
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700110 if ! [ -x "$(command -v ${PAHOLE})" ]; then
111 info "BTF" "${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700112 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700113 fi
114
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700115 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
116 if [ "${pahole_ver}" -lt "113" ]; then
117 info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700118 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700119 fi
120
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700121 info "BTF" ${2}
122 vmlinux_link ${1}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700123 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700124
125 # dump .BTF section into raw binary file to link with final vmlinux
Ilya Leoshkevichfdf37032019-08-20 13:29:39 +0200126 bin_arch=$(LANG=C ${OBJDUMP} -f ${1} | grep architecture | \
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700127 cut -d, -f1 | cut -d' ' -f2)
Ilya Leoshkevichfdf37032019-08-20 13:29:39 +0200128 bin_format=$(LANG=C ${OBJDUMP} -f ${1} | grep 'file format' | \
129 awk '{print $4}')
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800130 ${OBJCOPY} --set-section-flags .BTF=alloc -O binary \
131 --only-section=.BTF ${1} .btf.vmlinux.bin 2>/dev/null
Ilya Leoshkevichfdf37032019-08-20 13:29:39 +0200132 ${OBJCOPY} -I binary -O ${bin_format} -B ${bin_arch} \
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700133 --rename-section .data=.BTF .btf.vmlinux.bin ${2}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700134}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200135
136# Create ${2} .o file with all symbols from the ${1} object file
137kallsyms()
138{
139 info KSYM ${2}
140 local kallsymopt;
141
142 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100143 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200144 fi
145
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700146 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030147 kallsymopt="${kallsymopt} --absolute-percpu"
148 fi
149
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700150 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
151 kallsymopt="${kallsymopt} --base-relative"
152 fi
153
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200154 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
155 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200156
Ard Biesheuvela0439342016-02-05 11:25:05 +0100157 local afile="`basename ${2} .o`.S"
158
159 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
160 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200161}
162
Kees Cook8959e392019-08-13 08:15:32 -0700163# Perform one step in kallsyms generation, including temporary linking of
164# vmlinux.
165kallsyms_step()
166{
167 kallsymso_prev=${kallsymso}
168 kallsymso=.tmp_kallsyms${1}.o
169 kallsyms_vmlinux=.tmp_vmlinux${1}
170
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700171 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
Kees Cook8959e392019-08-13 08:15:32 -0700172 kallsyms ${kallsyms_vmlinux} ${kallsymso}
173}
174
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200175# Create map file with all symbols from ${1}
176# See mksymap for additional details
177mksysmap()
178{
179 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
180}
181
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700182sortextable()
183{
184 ${objtree}/scripts/sortextable ${1}
185}
186
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200187# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200188cleanup()
189{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700190 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200191 rm -f .tmp_System.map
192 rm -f .tmp_kallsyms*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200193 rm -f .tmp_vmlinux*
194 rm -f System.map
195 rm -f vmlinux
196 rm -f vmlinux.o
197}
198
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000199on_exit()
200{
201 if [ $? -ne 0 ]; then
202 cleanup
203 fi
204}
205trap on_exit EXIT
206
207on_signals()
208{
209 exit 1
210}
211trap on_signals HUP INT QUIT TERM
212
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200213#
214#
215# Use "make V=1" to debug this script
216case "${KBUILD_VERBOSE}" in
217*1*)
218 set -x
219 ;;
220esac
221
222if [ "$1" = "clean" ]; then
223 cleanup
224 exit 0
225fi
226
227# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900228. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200229
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200230# Update version
231info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900232if [ -r .version ]; then
233 VERSION=$(expr 0$(cat .version) + 1)
234 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200235else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900236 rm -f .version
237 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200238fi;
239
240# final build of init/
Cao jina7b151f2018-02-21 12:25:07 +0800241${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200242
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100243#link vmlinux.o
244info LD vmlinux.o
245modpost_link vmlinux.o
246
247# modpost vmlinux.o to check for section mismatches
Masahiro Yamadaa7215882019-07-31 00:59:02 +0900248${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100249
Alexey Gladkov898490c2019-04-29 18:11:14 +0200250info MODINFO modules.builtin.modinfo
251${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
252
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700253btf_vmlinux_bin_o=""
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700254if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700255 if gen_btf .tmp_vmlinux.btf .btf.vmlinux.bin.o ; then
256 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800257 else
258 echo >&2 "Failed to generate BTF for vmlinux"
259 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
260 exit 1
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700261 fi
262fi
263
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200264kallsymso=""
Kees Cook8959e392019-08-13 08:15:32 -0700265kallsymso_prev=""
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200266kallsyms_vmlinux=""
267if [ -n "${CONFIG_KALLSYMS}" ]; then
268
269 # kallsyms support
270 # Generate section listing all symbols and add it into vmlinux
271 # It's a three step process:
272 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
273 # but __kallsyms is empty.
274 # Running kallsyms on that gives us .tmp_kallsyms1.o with
275 # the right size
276 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
277 # the right size, but due to the added section, some
278 # addresses have shifted.
279 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100280 # 3) That link may have expanded the kernel image enough that
281 # more linker branch stubs / trampolines had to be added, which
282 # introduces new names, which further expands kallsyms. Do another
283 # pass if that is the case. In theory it's possible this results
284 # in even more stubs, but unlikely.
285 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
286 # other bugs.
287 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200288 #
289 # a) Verify that the System.map from vmlinux matches the map from
290 # ${kallsymso}.
291
Kees Cook8959e392019-08-13 08:15:32 -0700292 kallsyms_step 1
293 kallsyms_step 2
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200294
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100295 # step 3
Kees Cook8959e392019-08-13 08:15:32 -0700296 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
297 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100298
299 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Kees Cook8959e392019-08-13 08:15:32 -0700300 kallsyms_step 3
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200301 fi
302fi
303
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700304vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700305
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700306if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
307 info SORTEX vmlinux
308 sortextable vmlinux
309fi
310
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200311info SYSMAP System.map
312mksysmap vmlinux System.map
313
314# step a (see comment above)
315if [ -n "${CONFIG_KALLSYMS}" ]; then
316 mksysmap ${kallsyms_vmlinux} .tmp_System.map
317
318 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200319 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200320 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200321 exit 1
322 fi
323fi